/* Copyright (C) 2002-2003 RealVNC Ltd.  All Rights Reserved.
 *    
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */
//
// Cursor - structure containing information describing
//          the current cursor shape
//

#ifndef __RFB_CURSOR_H__
#define __RFB_CURSOR_H__

#include <rfb/PixelBuffer.h>

namespace rfb {

  class Cursor : public ManagedPixelBuffer {
  public:
    Cursor() {}
    rdr::U8Array mask;
    Point hotspot;
    int maskLen() { return (width() + 7) / 8 * height(); }
    virtual void setSize(int w, int h);
    void drawOutline(const Pixel& c);
    rdr::U8* getBitmap(Pixel* pix0, Pixel* pix1);
    // Crop the cursor, based on the mask.  Returns the resulting
    // *change* in the position of the hotspot.
    Point crop();
  };

}
#endif
