/* Copyright (C) 2002-2003 RealVNC Ltd.  All Rights Reserved.
 *    
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */
//
// AboutDialog.h
//

#ifndef __ABOUTDIALOG_H__
#define __ABOUTDIALOG_H__

#include "TXDialog.h"
#include "TXLabel.h"
#include "TXButton.h"
#include "parameters.h"

extern char buildtime[];

class AboutDialog : public TXDialog, public TXButtonCallback {
public:
  AboutDialog(Display* dpy)
    : TXDialog(dpy, 1, 1, "About VNCviewer"),
      aboutLabel(dpy, "", this),
      okButton(dpy, "OK", this, this, 60)
  {
    aboutLabel.xPad = 8;
    aboutLabel.move(0, yPad*4);
    aboutLabel.setText(aboutText);
    resize(aboutLabel.width(),
           aboutLabel.height() + okButton.height() + yPad*12);

    okButton.move((width() - okButton.width()) / 2,
                  height() - yPad*4 - okButton.height());
    setBorderWidth(1);
  }

  virtual void buttonActivate(TXButton* b) {
    unmap();
  }

  TXLabel aboutLabel;
  TXButton okButton;
};

#endif
